Python异常处理

作者: 风 哥 分类: Python 发布时间: 2019-01-03 21:26
广义上的错误分为错误和异常
错误指的是可以人为避免,异常是指在语法逻辑正确的前提下,出现的问题。
在Python中,异常是一个类,可以处理和使用
我们把可能发生错误的语句放在try模块里,用except来处理异常。except可以处理一个专门的异常,也可以处理一组圆括号中的异常,如果except后没有指定异常,则默认处理所有的异常。每一个try,都必须至少有一个except

异常名称 描述
BaseException 所有异常的基类
SystemExit 解释器请求退出
KeyboardInterrupt 用户中断执行(通常是输入^C)
Exception 常规错误的基类
StopIteration 迭代器没有更多的值
GeneratorExit 生成器(generator)发生异常来通知退出
SystemExit Python 解释器请求退出
StandardError 所有的内建标准异常的基类
ArithmeticError 所有数值计算错误的基类
FloatingPointError 浮点计算错误
OverflowError 数值运算超出最大限制
ZeroDivisionError 除(或取模)零 (所有数据类型)
AssertionError 断言语句失败
AttributeError 对象没有这个属性
EOFError 没有内建输入,到达EOF 标记
EnvironmentError 操作系统错误的基类
IOError 输入/输出操作失败
OSError 操作系统错误
WindowsError 系统调用失败
ImportError 导入模块/对象失败
KeyboardInterrupt 用户中断执行(通常是输入^C)
LookupError 无效数据查询的基类
IndexError 序列中没有没有此索引(index)
KeyError 映射中没有这个键
MemoryError 内存溢出错误(对于Python 解释器不是致命的)
NameError 未声明/初始化对象 (没有属性)
UnboundLocalError 访问未初始化的本地变量
ReferenceError 弱引用(Weak reference)试图访问已经垃圾回收了的对象
RuntimeError 一般的运行时错误
NotImplementedError 尚未实现的方法
SyntaxError Python 语法错误
IndentationError 缩进错误
TabError Tab 和空格混用
SystemError 一般的解释器系统错误
TypeError 对类型无效的操作
ValueError 传入无效的参数
UnicodeError Unicode 相关的错误
UnicodeDecodeError Unicode 解码时的错误
UnicodeEncodeError Unicode 编码时错误
UnicodeTranslateError Unicode 转换时错误
Warning 警告的基类
DeprecationWarning 关于被弃用的特征的警告
FutureWarning 关于构造将来语义会有改变的警告
OverflowWarning 旧的关于自动提升为长整型(long)的警告
PendingDeprecationWarning 关于特性将会被废弃的警告
RuntimeWarning 可疑的运行时行为(runtime behavior)的警告
SyntaxWarning 可疑的语法的警告
UserWarning 用户代码生成的警告

示例1、

#!/usr/bin/env python

#  -*- coding:utf-8 -*-

# 做除数运算

l = [1,2,3,4,5,6]

num = int(input("请输入一个数字"))
print(100/num)



结果:
请输入一个数字0
Traceback (most recent call last):
  File "F:/自动化平台/day12/try.py", line 10, in <module>
    print(100/num)
ZeroDivisionError: division by zero
# 异常处理,不能保证程序永远正确运行,但是,必须保证程序在最坏的情况下得到的问题被妥善处理
# Python的异常处理模块全部语法为:
try:
    尝试实现某个操作,
    如果没有出现异常,任务就可以完成
    如果出现异常,将异常从当前代码块扔出去尝试解决异常

except 异常类型1:
    解决方案1:用于尝试在此处处理异常解决问题

except 异常类型2:
    解决方案2:用于尝试在此处处理异常解决问题

except (异常类型1,异常类型2...):
    解决方案:针对多个异常使用相同的处理方式

else:
    如果没有任何异常,将会执行此处代码

finally:
    不管你有没有异常都要执行的代码
流程
1.执行try下面的语句
2.如果出现异常,则在except语句里查找对应异常并进行处理
3,.如果没有出现异常,则执行else语句内容
4.最后,不管是否出现异常,都要执行finall语句
除except(最少一个)以外,else和finall可选

#简单异常案例2

try:
    num = int(input("请输入一个数字: "))
    rst = 100/num
    print("计算结果是:{0}".format(rst))
except:
    print("你输入的内容不规范,程序已退出")
    #退出程序
    exit()

结果:
请输入一个数字: dd
你输入的内容不规范,程序已退出

#简单异常案例3
# 给出提示信息

try:
    num = int(input("请输入一个不为0的数字"))
    rst = 100/num
    print("计算结果为: {0}".format(rst))
#捕获异常后,把异常实例化,出错信息会在实例里
#注意以下写法
#以下语句是捕获ZeroDvivisionError异常并实例化实例e
except ZeroDivisionError as  e:
    print("请确认你输入的内容是否符合规范")
    print(e)
    #退出程序
    exit()

结果:

请输入一个不为0的数字0
请确认你输入的内容是否符合规范
division by zero

 

1、用户手动引发异常
当某些情况,用户希望自己引发一个异常的时候,可以使用raise关键字来引发异常

# raise案例

try:
    print("hello world")
    print(3.1415926)
    
    raise ValueError
    print("还没有结束啊?")
    
except NameError as  e:
    print("name error")
except ValueError as e:
    print("value error")
except Exception as e:
    print("有异常发生")
    
finally:
    print("我会被执行的")

执行结果:

hello world
3.1415926
value error
我会被执行的

2、 自定义异常, 需要注意:自定义异常必须是系统异常的子类

class GujiError(ValueError):
    pass
try:
    print("hello world")
    print(3.1415926)

    raise GujiError
    print("还没有结束啊?")

except GujiError as e:
    print("我是自定义的Error")

except NameError as  e:
    print("name error")
except ValueError as e:
    print("value error")
except Exception as e:
    print("有异常发生")

finally:
    print("我会被执行的")

执行结果:

hello world
3.1415926
我是自定义的Error
我会被执行的

 

 

发表评论

电子邮件地址不会被公开。 必填项已用*标注